VTK: vtkIncrementalForceLayout Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkIncrementalForceLayout Class Reference

incremental force-directed layout. More...

`#include <vtkIncrementalForceLayout.h>`

Inheritance diagram for vtkIncrementalForceLayout:
[legend]
Collaboration diagram for vtkIncrementalForceLayout:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkIncrementalForceLayout * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | SetGravityPoint (const vtkVector2f &point)
| Set the gravity point where all vertices will migrate. More...
virtual vtkVector2f | GetGravityPoint ()
void | UpdatePositions ()
| Perform one iteration of the force-directed layout. More...
virtual void | SetGraph (vtkGraph *g)
| Set the graph to be positioned. More...
virtual vtkGraph * | GetGraph ()
| Set the graph to be positioned. More...
virtual void | SetFixed (vtkIdType fixed)
| Set the id of the vertex that will not move during the simulation. More...
virtual vtkIdType | GetFixed ()
| Set the id of the vertex that will not move during the simulation. More...
virtual void | SetAlpha (float)
| Set the level of activity in the simulation. More...
virtual float | GetAlpha ()
| Set the level of activity in the simulation. More...
virtual void | SetTheta (float)
| Set the Barnes-Hut threshold for the simulation. More...
virtual float | GetTheta ()
| Set the Barnes-Hut threshold for the simulation. More...
virtual void | SetCharge (float)
| Set the charge of each vertex. More...
virtual float | GetCharge ()
| Set the charge of each vertex. More...
virtual void | SetStrength (float)
| Set the rigitity of links in the simulation. More...
virtual float | GetStrength ()
| Set the rigitity of links in the simulation. More...
virtual void | SetDistance (float)
| Set the resting distance of each link in scene units, which is equal to pixels when there is no scene scaling. More...
virtual float | GetDistance ()
| Set the resting distance of each link in scene units, which is equal to pixels when there is no scene scaling. More...
virtual void | SetGravity (float)
| Set the amount of gravitational pull toward the gravity point. More...
virtual float | GetGravity ()
| Set the amount of gravitational pull toward the gravity point. More...
virtual void | SetFriction (float)
| Set the multiplier for scaling down velocity in the simulation, where values closer to 1 are more frictionless. More...
virtual float | GetFriction ()
| Set the multiplier for scaling down velocity in the simulation, where values closer to 1 are more frictionless. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkIncrementalForceLayout * | SafeDownCast (vtkObjectBase *o)
static vtkIncrementalForceLayout * | New ()
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkIncrementalForceLayout ()
| ~vtkIncrementalForceLayout () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkGraph * | Graph
Implementation * | Impl
vtkIdType | Fixed
vtkVector2f | GravityPoint
float | Alpha
float | Theta
float | Charge
float | Strength
float | Distance
float | Gravity
float | Friction
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

incremental force-directed layout.

Performs an incremental force-directed layout of a graph. Set the graph then iteratively execute UpdatePositions() to update the vertex positions. Note that this directly modifies the vertex locations in the graph.

This layout is modeled after D3's force layout described at https://github.com/mbostock/d3/wiki/Force-Layout

Tests:
  vtkIncrementalForceLayout (Tests)

Definition at line 31 of file vtkIncrementalForceLayout.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkIncrementalForceLayout::Superclass

Definition at line 34 of file vtkIncrementalForceLayout.h.

## Constructor & Destructor Documentation

## ◆ vtkIncrementalForceLayout()

vtkIncrementalForceLayout::vtkIncrementalForceLayout | ( |  | ) |
| protected

## ◆ ~vtkIncrementalForceLayout()

vtkIncrementalForceLayout::~vtkIncrementalForceLayout | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkIncrementalForceLayout::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkIncrementalForceLayout::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

## ◆ SafeDownCast()

static vtkIncrementalForceLayout* vtkIncrementalForceLayout::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkIncrementalForceLayout::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkIncrementalForceLayout* vtkIncrementalForceLayout::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkIncrementalForceLayout::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkIncrementalForceLayout* vtkIncrementalForceLayout::New | ( |  | ) |
| static

## ◆ SetGraph()

virtual void vtkIncrementalForceLayout::SetGraph | ( | vtkGraph * | g | ) |
| virtual

Set the graph to be positioned.

## ◆ GetGraph()

virtual vtkGraph* vtkIncrementalForceLayout::GetGraph | ( |  | ) |
| virtual

Set the graph to be positioned.

## ◆ SetFixed()

virtual void vtkIncrementalForceLayout::SetFixed | ( | vtkIdType | fixed | ) |
| virtual

Set the id of the vertex that will not move during the simulation.

Set to -1 to allow all the vertices to move.

## ◆ GetFixed()

virtual vtkIdType vtkIncrementalForceLayout::GetFixed | ( |  | ) |
| virtual

Set the id of the vertex that will not move during the simulation.

Set to -1 to allow all the vertices to move.

## ◆ SetAlpha()

virtual void vtkIncrementalForceLayout::SetAlpha | ( | float |  | ) |
| virtual

Set the level of activity in the simulation.

Default is 0.1.

## ◆ GetAlpha()

virtual float vtkIncrementalForceLayout::GetAlpha | ( |  | ) |
| virtual

Set the level of activity in the simulation.

Default is 0.1.

## ◆ SetTheta()

virtual void vtkIncrementalForceLayout::SetTheta | ( | float |  | ) |
| virtual

Set the Barnes-Hut threshold for the simulation.

Higher values will speed the simulation at the expense of some accuracy. Default is 0.8.

## ◆ GetTheta()

virtual float vtkIncrementalForceLayout::GetTheta | ( |  | ) |
| virtual

Set the Barnes-Hut threshold for the simulation.

Higher values will speed the simulation at the expense of some accuracy. Default is 0.8.

## ◆ SetCharge()

virtual void vtkIncrementalForceLayout::SetCharge | ( | float |  | ) |
| virtual

Set the charge of each vertex.

Higher negative values will repel vertices from each other more strongly. Default is -30.

## ◆ GetCharge()

virtual float vtkIncrementalForceLayout::GetCharge | ( |  | ) |
| virtual

Set the charge of each vertex.

Higher negative values will repel vertices from each other more strongly. Default is -30.

## ◆ SetStrength()

virtual void vtkIncrementalForceLayout::SetStrength | ( | float |  | ) |
| virtual

Set the rigitity of links in the simulation.

Default is 2.

## ◆ GetStrength()

virtual float vtkIncrementalForceLayout::GetStrength | ( |  | ) |
| virtual

Set the rigitity of links in the simulation.

Default is 2.

## ◆ SetDistance()

virtual void vtkIncrementalForceLayout::SetDistance | ( | float |  | ) |
| virtual

Set the resting distance of each link in scene units, which is equal to pixels when there is no scene scaling.

Default is 20.

## ◆ GetDistance()

virtual float vtkIncrementalForceLayout::GetDistance | ( |  | ) |
| virtual

Set the resting distance of each link in scene units, which is equal to pixels when there is no scene scaling.

Default is 20.

## ◆ SetGravity()

virtual void vtkIncrementalForceLayout::SetGravity | ( | float |  | ) |
| virtual

Set the amount of gravitational pull toward the gravity point.

Default is 0.01.

## ◆ GetGravity()

virtual float vtkIncrementalForceLayout::GetGravity | ( |  | ) |
| virtual

Set the amount of gravitational pull toward the gravity point.

Default is 0.01.

## ◆ SetFriction()

virtual void vtkIncrementalForceLayout::SetFriction | ( | float |  | ) |
| virtual

Set the multiplier for scaling down velocity in the simulation, where values closer to 1 are more frictionless.

Default is 0.95.

## ◆ GetFriction()

virtual float vtkIncrementalForceLayout::GetFriction | ( |  | ) |
| virtual

Set the multiplier for scaling down velocity in the simulation, where values closer to 1 are more frictionless.

Default is 0.95.

## ◆ SetGravityPoint()

virtual void vtkIncrementalForceLayout::SetGravityPoint | ( | const vtkVector2f & | point | ) |
| inlinevirtual

Set the gravity point where all vertices will migrate.

Generally this should be set to the location in the center of the scene. Default location is (200, 200).

Definition at line 122 of file vtkIncrementalForceLayout.h.

## ◆ GetGravityPoint()

virtual vtkVector2f vtkIncrementalForceLayout::GetGravityPoint | ( |  | ) |
| inlinevirtual

Definition at line 123 of file vtkIncrementalForceLayout.h.

## ◆ UpdatePositions()

void vtkIncrementalForceLayout::UpdatePositions | ( |  | ) |

Perform one iteration of the force-directed layout.

## Member Data Documentation

## ◆ Graph

vtkGraph* vtkIncrementalForceLayout::Graph
| protected

Definition at line 134 of file vtkIncrementalForceLayout.h.

## ◆ Impl

Implementation* vtkIncrementalForceLayout::Impl
| protected

Definition at line 136 of file vtkIncrementalForceLayout.h.

## ◆ Fixed

vtkIdType vtkIncrementalForceLayout::Fixed
| protected

Definition at line 137 of file vtkIncrementalForceLayout.h.

## ◆ GravityPoint

vtkVector2f vtkIncrementalForceLayout::GravityPoint
| protected

Definition at line 138 of file vtkIncrementalForceLayout.h.

## ◆ Alpha

float vtkIncrementalForceLayout::Alpha
| protected

Definition at line 139 of file vtkIncrementalForceLayout.h.

## ◆ Theta

float vtkIncrementalForceLayout::Theta
| protected

Definition at line 140 of file vtkIncrementalForceLayout.h.

## ◆ Charge

float vtkIncrementalForceLayout::Charge
| protected

Definition at line 141 of file vtkIncrementalForceLayout.h.

## ◆ Strength

float vtkIncrementalForceLayout::Strength
| protected

Definition at line 142 of file vtkIncrementalForceLayout.h.

## ◆ Distance

float vtkIncrementalForceLayout::Distance
| protected

Definition at line 143 of file vtkIncrementalForceLayout.h.

## ◆ Gravity

float vtkIncrementalForceLayout::Gravity
| protected

Definition at line 144 of file vtkIncrementalForceLayout.h.

## ◆ Friction

float vtkIncrementalForceLayout::Friction
| protected

Definition at line 145 of file vtkIncrementalForceLayout.h.

The documentation for this class was generated from the following file:

- Infovis/Layout/vtkIncrementalForceLayout.h